// gs.js
window.onload = boot

const ID_Q = "idQ",
        ID_BTN_SEARCH = "idBtnSearch",
        ID_CHECK_ORDER_IS_RELEVANT = "idCheckOrderIsRelevant",
        ID_STARTING_RANK = "idStartingRank",
        ID_HOW_MANY_RESULTS = "idHowManyResults",
        ID_TEXT_FILTER = "idTextFilter",
        ID_SELECT_FILTER = "idSelectFilter"

const URL_BASE = "https://www.google.com/search?"

var oQ, oBtnSearch, oCheckOrderIsRelevant,
    oStartingRank,
    oHowManyResults,
    oTextFilter, oSelectFilter

function id(pId){
    return document.getElementById(pId)
}//id

function boot(){
    // associações / bindings
    oQ = id(ID_Q)
    oBtnSearch = id(ID_BTN_SEARCH)
    oCheckOrderIsRelevant = id(ID_CHECK_ORDER_IS_RELEVANT)
    oStartingRank = id(ID_STARTING_RANK)
    oHowManyResults = id(ID_HOW_MANY_RESULTS)
    oTextFilter = id(ID_TEXT_FILTER)
    oSelectFilter = id(ID_SELECT_FILTER)

    // controlo de qualidade
    // TODO

    // comportamentos / behavior setting
    oBtnSearch.onclick = go_search
}//boot

function build_query_string(){
    var search_expression =
        encodeURIComponent(
            oQ.value.trim() // elimina espaços em branco à esquerda *e* à direita
        )

    var b_order_is_relevant =
        oCheckOrderIsRelevant.checked

    var i_starting_rank = Number(
        oStartingRank.value
    )

    var qs = b_order_is_relevant ?
        URL_BASE+"as_epq="+search_expression
        :
        URL_BASE+"q="+search_expression

    qs+="&start=" + i_starting_rank.toString()

    var numOfResults = Number(oHowManyResults.value)
    qs+="&num=" + numOfResults

    var textFilter = oTextFilter.value.trim()
    var selectFilter = oSelectFilter.value.trim()
    var filter = textFilter!="" ?
        textFilter
        :
        selectFilter
    filter = filter=="all" ?
        ""
        :
        encodeURIComponent(filter)

    if(filter!="")
        qs+="&as_sitesearch="+filter

    // return undefined
    return qs
}//build_query_string

function go_search(){
    var qs = build_query_string()

    document.location.href = qs
}//go_search